library CoverPlug;

uses
  SysUtils,
  Classes,
  Forms,
  FreeRaportHeader in 'FreeRaportHeader.pas',
  Main in 'Main.pas' {Form1},
  Unit2 in 'Unit2.pas' {Form2},
  Unit3 in 'Unit3.pas' {Form3};

var
  PlugType:PChar = '  CD'; //   

  Additional1Name:string = '  1';
  Additional2Name:string = '  2';
  Additional3Name:string = '  3';
  Additional4Name:string = '  4';



function EnumCallBackProc(Const State,Level,LevelType:integer;Const Info:pDBRec):integer;stdcall;
//    
begin
  result:=EN_ERROR_NONE;
  case State of
    MC_RAP_START:try
                   Form1:=TForm1.Create(Application);
                   Form1.Init;
                   //Form1.Show;
                   Form1.PrintPreview1.BeginDoc;
                   TitleRight:=-1;
                   Form1.AddPage;
                   firstPage:=true;
                   CoverTitle:=Info.Title;
                   Form1.DrawTitle;
                   MaxTreeLevel:=Level;
                 except
                   result:=EN_ERROR_INTERNALERROR;
                 end;
    MC_RAP_LEVEL:try
                   ItemCount:=-1;
                   Form1.DrawItem(Info^,Level,-1);
                   LastItemIsEl:=false;
                 except
                   result:=EN_ERROR_INTERNALERROR;
                 end;
    MC_RAP_El:try
                if ItemCount=-1 then ItemCount:=1;
                Form1.DrawItem(Info^,-1,ItemCount);
                inc(ItemCount);
                LastItemIsEl:=true;
              except
                result:=EN_ERROR_INTERNALERROR;
              end;
    MC_RAP_CLOSE:try
                   if Level=0 then
                   begin
                     Form1.PrintPreview1.EndDoc;
                     Form1.SetButtonState;
                     //Form1.ParentWindow:=OwnerWND;
                     Form1.ShowModal;
                   end;
                   if not NeedRepeat then FreeAndNil(Form1);
                 except
                   result:=EN_ERROR_INTERNALERROR;
                 end;
  end;
end;

procedure RapInitProc(Var PluginType:PChar;Const Owner:THandle);stdcall;
//  
begin
  PluginType:=PlugType; //   
  OwnerWND:=Owner; //    
  Application.Handle := OwnerWND;
end;

function EnumNeedRepeat:boolean;stdcall;
//     
begin
  byte(result):=byte(NeedRepeat);
  if NeedRepeat then
  begin
    Form1.Init;
    Form1.PrintPreview1.BeginDoc;
    Form1.AddPage;
    firstPage:=true;
    LastItemIsEl:=true;
    Form1.DrawTitle;
  end;
  NeedRepeat:=false;
end;

procedure Configure(Const Owner:THandle);stdcall;
begin
  Form2:=TForm2.Create(nil,Owner);
  Form2.ShowModal;
  Form2.Free;
end;

procedure SetAdditionalNames(Const A1,A2,A3,A4:PChar);stdcall;
//     (MuzCat       )
begin
 Additional1Name:=A1;
 Additional2Name:=A2;
 Additional3Name:=A3;
 Additional4Name:=A4;
end;


//        
exports
  EnumCallBackProc,
  RapInitProc,
  EnumNeedRepeat,
  Configure,
  SetAdditionalNames;



begin
end.
